Index: trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php	(revision 265)
@@ -1,19 +1,19 @@
 <?php
 /*=======================================================================
-// File:	JPGRAPH_GANTT.PHP
-// Description:	JpGraph Gantt plot extension
-// Created: 	2001-11-12
-// Ver:		$Id: jpgraph_gantt.php 1091 2009-01-18 22:57:40Z ljp $
-//
-// Copyright (c) Aditus Consulting. All rights reserved.
-//========================================================================
-*/
-
-require_once('jpgraph_plotband.php'); 
-require_once('jpgraph_iconplot.php'); 
+ // File:        JPGRAPH_GANTT.PHP
+ // Description: JpGraph Gantt plot extension
+ // Created:     2001-11-12
+ // Ver:         $Id: jpgraph_gantt.php 1809 2009-09-09 13:07:33Z ljp $
+ //
+ // Copyright (c) Asial Corporation. All rights reserved.
+ //========================================================================
+ */
+
+require_once('jpgraph_plotband.php');
+require_once('jpgraph_iconplot.php');
 require_once('jpgraph_plotmark.inc.php');
 
 // Maximum size for Automatic Gantt chart
-define('MAX_GANTTIMG_SIZE_W',4000);
+define('MAX_GANTTIMG_SIZE_W',8000);
 define('MAX_GANTTIMG_SIZE_H',5000);
 
@@ -27,5 +27,5 @@
 
 // Bar patterns
-define("GANTT_RDIAG",BAND_RDIAG);	// Right diagonal lines
+define("GANTT_RDIAG",BAND_RDIAG); // Right diagonal lines
 define("GANTT_LDIAG",BAND_LDIAG); // Left diagonal lines
 define("GANTT_SOLID",BAND_SOLID); // Solid one color
@@ -40,6 +40,6 @@
 
 // Locales. ONLY KEPT FOR BACKWARDS COMPATIBILITY
-// You should use the proper locale strings directly 
-// from now on. 
+// You should use the proper locale strings directly
+// from now on.
 define("LOCALE_EN","en_UK");
 define("LOCALE_SV","sv_SE");
@@ -50,29 +50,29 @@
 
 // Style for minute header
-define("MINUTESTYLE_MM",0);		// 15
-define("MINUTESTYLE_CUSTOM",2);		// Custom format
+define("MINUTESTYLE_MM",0);  // 15
+define("MINUTESTYLE_CUSTOM",2);  // Custom format
 
 
 // Style for hour header
-define("HOURSTYLE_HM24",0);		// 13:10
-define("HOURSTYLE_HMAMPM",1);		// 1:10pm
-define("HOURSTYLE_H24",2);		// 13
-define("HOURSTYLE_HAMPM",3);		// 1pm
-define("HOURSTYLE_CUSTOM",4);		// User defined
+define("HOURSTYLE_HM24",0);  // 13:10
+define("HOURSTYLE_HMAMPM",1);  // 1:10pm
+define("HOURSTYLE_H24",2);  // 13
+define("HOURSTYLE_HAMPM",3);  // 1pm
+define("HOURSTYLE_CUSTOM",4);  // User defined
 
 // Style for day header
-define("DAYSTYLE_ONELETTER",0);		// "M"
-define("DAYSTYLE_LONG",1);		// "Monday"
-define("DAYSTYLE_LONGDAYDATE1",2);	// "Monday 23 Jun"
-define("DAYSTYLE_LONGDAYDATE2",3);	// "Monday 23 Jun 2003"
-define("DAYSTYLE_SHORT",4);		// "Mon"
-define("DAYSTYLE_SHORTDAYDATE1",5);	// "Mon 23/6"
-define("DAYSTYLE_SHORTDAYDATE2",6);	// "Mon 23 Jun"
-define("DAYSTYLE_SHORTDAYDATE3",7);	// "Mon 23"
-define("DAYSTYLE_SHORTDATE1",8);	// "23/6"
-define("DAYSTYLE_SHORTDATE2",9);	// "23 Jun"
-define("DAYSTYLE_SHORTDATE3",10);	// "Mon 23"
-define("DAYSTYLE_SHORTDATE4",11);	// "23"
-define("DAYSTYLE_CUSTOM",12);		// "M"
+define("DAYSTYLE_ONELETTER",0);  // "M"
+define("DAYSTYLE_LONG",1);  // "Monday"
+define("DAYSTYLE_LONGDAYDATE1",2); // "Monday 23 Jun"
+define("DAYSTYLE_LONGDAYDATE2",3); // "Monday 23 Jun 2003"
+define("DAYSTYLE_SHORT",4);  // "Mon"
+define("DAYSTYLE_SHORTDAYDATE1",5); // "Mon 23/6"
+define("DAYSTYLE_SHORTDAYDATE2",6); // "Mon 23 Jun"
+define("DAYSTYLE_SHORTDAYDATE3",7); // "Mon 23"
+define("DAYSTYLE_SHORTDATE1",8); // "23/6"
+define("DAYSTYLE_SHORTDATE2",9); // "23 Jun"
+define("DAYSTYLE_SHORTDATE3",10); // "Mon 23"
+define("DAYSTYLE_SHORTDATE4",11); // "23"
+define("DAYSTYLE_CUSTOM",12);  // "M"
 
 // Styles for week header
@@ -128,9 +128,9 @@
 if (!function_exists('array_fill')) {
     function array_fill($iStart, $iLen, $vValue) {
-	$aResult = array();
-	for ($iCount = $iStart; $iCount < $iLen + $iStart; $iCount++) {
-	    $aResult[$iCount] = $vValue;
-	}
-	return $aResult;
+        $aResult = array();
+        for ($iCount = $iStart; $iCount < $iLen + $iStart; $iCount++) {
+            $aResult[$iCount] = $vValue;
+        }
+        return $aResult;
     }
 }
@@ -138,5 +138,5 @@
 //===================================================
 // CLASS GanttActivityInfo
-// Description: 
+// Description:
 //===================================================
 class GanttActivityInfo {
@@ -153,172 +153,171 @@
     private $iHeaderAlign='center';
 
-    function GanttActivityInfo() {
-	$this->vgrid = new LineProperty();
+    function __construct() {
+        $this->vgrid = new LineProperty();
     }
 
     function Hide($aF=true) {
-	$this->iShow=!$aF;
+        $this->iShow=!$aF;
     }
 
     function Show($aF=true) {
-	$this->iShow=$aF;
+        $this->iShow=$aF;
     }
 
     // Specify font
     function SetFont($aFFamily,$aFStyle=FS_NORMAL,$aFSize=10) {
-	$this->iFFamily = $aFFamily;
-	$this->iFStyle	 = $aFStyle;
-	$this->iFSize	 = $aFSize;
+        $this->iFFamily = $aFFamily;
+        $this->iFStyle  = $aFStyle;
+        $this->iFSize  = $aFSize;
     }
 
     function SetStyle($aStyle) {
-	$this->iStyle = $aStyle;
+        $this->iStyle = $aStyle;
     }
 
     function SetColumnMargin($aLeft,$aRight) {
-	$this->iLeftColMargin = $aLeft;
-	$this->iRightColMargin = $aRight;
+        $this->iLeftColMargin = $aLeft;
+        $this->iRightColMargin = $aRight;
     }
 
     function SetFontColor($aFontColor) {
-	$this->iFontColor = $aFontColor;
+        $this->iFontColor = $aFontColor;
     }
 
     function SetColor($aColor) {
-	$this->iColor = $aColor;
+        $this->iColor = $aColor;
     }
 
     function SetBackgroundColor($aColor) {
-	$this->iBackgroundColor = $aColor;
+        $this->iBackgroundColor = $aColor;
     }
 
     function SetColTitles($aTitles,$aWidth=null) {
-	$this->iTitles = $aTitles;
-	$this->iWidth = $aWidth;
+        $this->iTitles = $aTitles;
+        $this->iWidth = $aWidth;
     }
 
     function SetMinColWidth($aWidths) {
-	$n = min(count($this->iTitles),count($aWidths));
-	for($i=0; $i < $n; ++$i ) {
-	    if( !empty($aWidths[$i]) ) {
-		if( empty($this->iWidth[$i]) ) {
-		    $this->iWidth[$i] = $aWidths[$i];
-		}
-		else {
-		    $this->iWidth[$i] = max($this->iWidth[$i],$aWidths[$i]);
-		}
-	    }
-	}
+        $n = min(count($this->iTitles),count($aWidths));
+        for($i=0; $i < $n; ++$i ) {
+            if( !empty($aWidths[$i]) ) {
+                if( empty($this->iWidth[$i]) ) {
+                    $this->iWidth[$i] = $aWidths[$i];
+                }
+                else {
+                    $this->iWidth[$i] = max($this->iWidth[$i],$aWidths[$i]);
+                }
+            }
+        }
     }
 
     function GetWidth($aImg) {
-	$txt = new TextProperty();
-	$txt->SetFont($this->iFFamily,$this->iFStyle,$this->iFSize);
-	$n = count($this->iTitles) ;
-	$rm=$this->iRightColMargin;
-	$w = 0;
-	for($h=0, $i=0; $i < $n; ++$i ) {
-	    $w += $this->iLeftColMargin;
-	    $txt->Set($this->iTitles[$i]);
-	    if( !empty($this->iWidth[$i]) ) {
-		$w1 = max($txt->GetWidth($aImg)+$rm,$this->iWidth[$i]);
-	    }
-	    else {
-		$w1 = $txt->GetWidth($aImg)+$rm;
-	    }
-	    $this->iWidth[$i] = $w1;
-	    $w += $w1;
-	    $h = max($h,$txt->GetHeight($aImg));
-	}
-	$this->iHeight = $h+$this->iTopHeaderMargin;
+        $txt = new TextProperty();
+        $txt->SetFont($this->iFFamily,$this->iFStyle,$this->iFSize);
+        $n = count($this->iTitles) ;
+        $rm=$this->iRightColMargin;
+        $w = 0;
+        for($h=0, $i=0; $i < $n; ++$i ) {
+            $w += $this->iLeftColMargin;
+            $txt->Set($this->iTitles[$i]);
+            if( !empty($this->iWidth[$i]) ) {
+                $w1 = max($txt->GetWidth($aImg)+$rm,$this->iWidth[$i]);
+            }
+            else {
+                $w1 = $txt->GetWidth($aImg)+$rm;
+            }
+            $this->iWidth[$i] = $w1;
+            $w += $w1;
+            $h = max($h,$txt->GetHeight($aImg));
+        }
+        $this->iHeight = $h+$this->iTopHeaderMargin;
         $txt='';
-	return $w;
-    }
-    
+        return $w;
+    }
+
     function GetColStart($aImg,&$aStart,$aAddLeftMargin=false) {
-	$n = count($this->iTitles) ;
-	$adj = $aAddLeftMargin ? $this->iLeftColMargin : 0;
-	$aStart=array($aImg->left_margin+$adj);
-	for( $i=1; $i < $n; ++$i ) {
-	    $aStart[$i] = $aStart[$i-1]+$this->iLeftColMargin+$this->iWidth[$i-1];
-	}
-    }
-    
+        $n = count($this->iTitles) ;
+        $adj = $aAddLeftMargin ? $this->iLeftColMargin : 0;
+        $aStart=array($aImg->left_margin+$adj);
+        for( $i=1; $i < $n; ++$i ) {
+            $aStart[$i] = $aStart[$i-1]+$this->iLeftColMargin+$this->iWidth[$i-1];
+        }
+    }
+
     // Adjust headers left, right or centered
     function SetHeaderAlign($aAlign) {
-	$this->iHeaderAlign=$aAlign;
+        $this->iHeaderAlign=$aAlign;
     }
 
     function Stroke($aImg,$aXLeft,$aYTop,$aXRight,$aYBottom,$aUseTextHeight=false) {
 
-	if( !$this->iShow ) return;
-
-	$txt = new TextProperty();
-	$txt->SetFont($this->iFFamily,$this->iFStyle,$this->iFSize);
-	$txt->SetColor($this->iFontColor);
-	$txt->SetAlign($this->iHeaderAlign,'top');
-	$n=count($this->iTitles);
-
-	if( $n == 0 ) 
-	    return;
-	
-	$x = $aXLeft;
-	$h = $this->iHeight;
-	$yTop = $aUseTextHeight ? $aYBottom-$h-$this->iTopColMargin-$this->iBottomColMargin : $aYTop ;
-
-	if( $h < 0 ) {
-	    JpGraphError::RaiseL(6001);
-//('Internal error. Height for ActivityTitles is < 0');
-	}
-
-	$aImg->SetLineWeight(1);
-	// Set background color
-	$aImg->SetColor($this->iBackgroundColor);
-	$aImg->FilledRectangle($aXLeft,$yTop,$aXRight,$aYBottom-1);
-
-	if( $this->iStyle == 1 ) {
-	    // Make a 3D effect
-	    $aImg->SetColor('white');
-	    $aImg->Line($aXLeft,$yTop+1,
-			$aXRight,$yTop+1);
-	}
-	
-	for($i=0; $i < $n; ++$i ) {
-	    if( $this->iStyle == 1 ) {
-		// Make a 3D effect
-		$aImg->SetColor('white');
-		$aImg->Line($x+1,$yTop,$x+1,$aYBottom);
-	    }
-	    $x += $this->iLeftColMargin;
-	    $txt->Set($this->iTitles[$i]);
-	    
-	    // Adjust the text anchor position according to the choosen alignment
-	    $xp = $x;
-	    if( $this->iHeaderAlign == 'center' ) {
-		$xp = (($x-$this->iLeftColMargin)+($x+$this->iWidth[$i]))/2;
-	    }
-	    elseif( $this->iHeaderAlign == 'right' ) {
-		$xp = $x +$this->iWidth[$i]-$this->iRightColMargin;
-	    }
-		    
-	    $txt->Stroke($aImg,$xp,$yTop+$this->iTopHeaderMargin);
-	    $x += $this->iWidth[$i];
-	    if( $i < $n-1 ) {
-		$aImg->SetColor($this->iColor);
-		$aImg->Line($x,$yTop,$x,$aYBottom);
-	    }
-	}
-
-	$aImg->SetColor($this->iColor);
-	$aImg->Line($aXLeft,$yTop, $aXRight,$yTop);
-
-	// Stroke vertical column dividers
-	$cols=array();
-	$this->GetColStart($aImg,$cols);
-	$n=count($cols);
-	for( $i=1; $i < $n; ++$i ) {
-	    $this->vgrid->Stroke($aImg,$cols[$i],$aYBottom,$cols[$i],
-				    $aImg->height - $aImg->bottom_margin);
-	}
+        if( !$this->iShow ) return;
+
+        $txt = new TextProperty();
+        $txt->SetFont($this->iFFamily,$this->iFStyle,$this->iFSize);
+        $txt->SetColor($this->iFontColor);
+        $txt->SetAlign($this->iHeaderAlign,'top');
+        $n=count($this->iTitles);
+
+        if( $n == 0 )
+        return;
+
+        $x = $aXLeft;
+        $h = $this->iHeight;
+        $yTop = $aUseTextHeight ? $aYBottom-$h-$this->iTopColMargin-$this->iBottomColMargin : $aYTop ;
+
+        if( $h < 0 ) {
+            JpGraphError::RaiseL(6001);
+            //('Internal error. Height for ActivityTitles is < 0');
+        }
+
+        $aImg->SetLineWeight(1);
+        // Set background color
+        $aImg->SetColor($this->iBackgroundColor);
+        $aImg->FilledRectangle($aXLeft,$yTop,$aXRight,$aYBottom-1);
+
+        if( $this->iStyle == 1 ) {
+            // Make a 3D effect
+            $aImg->SetColor('white');
+            $aImg->Line($aXLeft,$yTop+1,$aXRight,$yTop+1);
+        }
+
+        for($i=0; $i < $n; ++$i ) {
+            if( $this->iStyle == 1 ) {
+                // Make a 3D effect
+                $aImg->SetColor('white');
+                $aImg->Line($x+1,$yTop,$x+1,$aYBottom);
+            }
+            $x += $this->iLeftColMargin;
+            $txt->Set($this->iTitles[$i]);
+
+            // Adjust the text anchor position according to the choosen alignment
+            $xp = $x;
+            if( $this->iHeaderAlign == 'center' ) {
+                $xp = (($x-$this->iLeftColMargin)+($x+$this->iWidth[$i]))/2;
+            }
+            elseif( $this->iHeaderAlign == 'right' ) {
+                $xp = $x +$this->iWidth[$i]-$this->iRightColMargin;
+            }
+
+            $txt->Stroke($aImg,$xp,$yTop+$this->iTopHeaderMargin);
+            $x += $this->iWidth[$i];
+            if( $i < $n-1 ) {
+                $aImg->SetColor($this->iColor);
+                $aImg->Line($x,$yTop,$x,$aYBottom);
+            }
+        }
+
+        $aImg->SetColor($this->iColor);
+        $aImg->Line($aXLeft,$yTop, $aXRight,$yTop);
+
+        // Stroke vertical column dividers
+        $cols=array();
+        $this->GetColStart($aImg,$cols);
+        $n=count($cols);
+        for( $i=1; $i < $n; ++$i ) {
+            $this->vgrid->Stroke($aImg,$cols[$i],$aYBottom,$cols[$i],
+            $aImg->height - $aImg->bottom_margin);
+        }
     }
 }
@@ -330,191 +329,221 @@
 //===================================================
 class GanttGraph extends Graph {
-    public $scale;		// Public accessible
+    public $scale;  // Public accessible
     public $hgrid=null;
-    private $iObj=array();				// Gantt objects
-    private $iLabelHMarginFactor=0.2;	// 10% margin on each side of the labels
-    private $iLabelVMarginFactor=0.4;	// 40% margin on top and bottom of label
-    private $iLayout=GANTT_FROMTOP;	// Could also be GANTT_EVEN
+    private $iObj=array();    // Gantt objects
+    private $iLabelHMarginFactor=0.2; // 10% margin on each side of the labels
+    private $iLabelVMarginFactor=0.4; // 40% margin on top and bottom of label
+    private $iLayout=GANTT_FROMTOP; // Could also be GANTT_EVEN
     private $iSimpleFont = FF_FONT1,$iSimpleFontSize=11;
     private $iSimpleStyle=GANTT_RDIAG,$iSimpleColor='yellow',$iSimpleBkgColor='red';
     private $iSimpleProgressBkgColor='gray',$iSimpleProgressColor='darkgreen';
     private $iSimpleProgressStyle=GANTT_SOLID;
-//---------------
-// CONSTRUCTOR	
+    private $iZoomFactor = 1.0;
+    //---------------
+    // CONSTRUCTOR
     // Create a new gantt graph
-    function GanttGraph($aWidth=0,$aHeight=0,$aCachedName="",$aTimeOut=0,$aInline=true) {
-
-	// Backward compatibility
-	if( $aWidth == -1 ) $aWidth=0;
-	if( $aHeight == -1 ) $aHeight=0;
-
-	if( $aWidth<  0 || $aHeight < 0 ) {
-	    JpgraphError::RaiseL(6002);
-//("You can't specify negative sizes for Gantt graph dimensions. Use 0 to indicate that you want the library to automatically determine a dimension.");
-	}
-	Graph::Graph($aWidth,$aHeight,$aCachedName,$aTimeOut,$aInline);		
-	$this->scale = new GanttScale($this->img);
-
-	// Default margins
-	$this->img->SetMargin(15,17,25,15);
-
-	$this->hgrid = new HorizontalGridLine();
-		
-	$this->scale->ShowHeaders(GANTT_HWEEK|GANTT_HDAY);
-	$this->SetBox();
-    }
-	
-//---------------
-// PUBLIC METHODS
-
-    // 
+    function __construct($aWidth=0,$aHeight=0,$aCachedName="",$aTimeOut=0,$aInline=true) {
+
+        // Backward compatibility
+        if( $aWidth == -1 ) $aWidth=0;
+        if( $aHeight == -1 ) $aHeight=0;
+
+        if( $aWidth<  0 || $aHeight < 0 ) {
+            JpgraphError::RaiseL(6002);
+            //("You can't specify negative sizes for Gantt graph dimensions. Use 0 to indicate that you want the library to automatically determine a dimension.");
+        }
+        parent::__construct($aWidth,$aHeight,$aCachedName,$aTimeOut,$aInline);
+        $this->scale = new GanttScale($this->img);
+
+        // Default margins
+        $this->img->SetMargin(15,17,25,15);
+
+        $this->hgrid = new HorizontalGridLine();
+
+        $this->scale->ShowHeaders(GANTT_HWEEK|GANTT_HDAY);
+        $this->SetBox();
+    }
+
+    //---------------
+    // PUBLIC METHODS
+
+    //
 
     function SetSimpleFont($aFont,$aSize) {
-	$this->iSimpleFont = $aFont;
-	$this->iSimpleFontSize = $aSize;
+        $this->iSimpleFont = $aFont;
+        $this->iSimpleFontSize = $aSize;
     }
 
     function SetSimpleStyle($aBand,$aColor,$aBkgColor) {
-	$this->iSimpleStyle = $aBand;
-	$this->iSimpleColor = $aColor;
-	$this->iSimpleBkgColor = $aBkgColor;
+        $this->iSimpleStyle = $aBand;
+        $this->iSimpleColor = $aColor;
+        $this->iSimpleBkgColor = $aBkgColor;
     }
 
     // A utility function to help create basic Gantt charts
     function CreateSimple($data,$constrains=array(),$progress=array()) {
-	$num = count($data);
-	for( $i=0; $i < $num; ++$i) {
-	    switch( $data[$i][1] ) {
-		case ACTYPE_GROUP:
-		    // Create a slightly smaller height bar since the
-		    // "wings" at the end will make it look taller
-		    $a = new GanttBar($data[$i][0],$data[$i][2],$data[$i][3],$data[$i][4],'',8);
-		    $a->title->SetFont($this->iSimpleFont,FS_BOLD,$this->iSimpleFontSize);		
-		    $a->rightMark->Show();
-		    $a->rightMark->SetType(MARK_RIGHTTRIANGLE);
-		    $a->rightMark->SetWidth(8);
-		    $a->rightMark->SetColor('black');
-		    $a->rightMark->SetFillColor('black');
-	    
-		    $a->leftMark->Show();
-		    $a->leftMark->SetType(MARK_LEFTTRIANGLE);
-		    $a->leftMark->SetWidth(8);
-		    $a->leftMark->SetColor('black');
-		    $a->leftMark->SetFillColor('black');
-	    
-		    $a->SetPattern(BAND_SOLID,'black');
-		    $csimpos = 6;
-		    break;
-		
-		case ACTYPE_NORMAL:
-		    $a = new GanttBar($data[$i][0],$data[$i][2],$data[$i][3],$data[$i][4],'',10);
-		    $a->title->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
-		    $a->SetPattern($this->iSimpleStyle,$this->iSimpleColor);
-		    $a->SetFillColor($this->iSimpleBkgColor);
-		    // Check if this activity should have a constrain line
-		    $n = count($constrains);
-		    for( $j=0; $j < $n; ++$j ) {
-			if( empty($constrains[$j]) || (count($constrains[$j]) != 3) ) {
-			    JpGraphError::RaiseL(6003,$j);
-//("Invalid format for Constrain parameter at index=$j in CreateSimple(). Parameter must start with index 0 and contain arrays of (Row,Constrain-To,Constrain-Type)");	 
-			}
-			if( $constrains[$j][0]==$data[$i][0] ) {
-			    $a->SetConstrain($constrains[$j][1],$constrains[$j][2],'black',ARROW_S2,ARROWT_SOLID);    
-			}
-		    }
-
-		    // Check if this activity have a progress bar
-		    $n = count($progress);
-		    for( $j=0; $j < $n; ++$j ) {
-			
-			if( empty($progress[$j]) || (count($progress[$j]) != 2) ) {
-			    JpGraphError::RaiseL(6004,$j);
-//("Invalid format for Progress parameter at index=$j in CreateSimple(). Parameter must start with index 0 and contain arrays of (Row,Progress)");	
-			}
-			if( $progress[$j][0]==$data[$i][0] ) {
-			    $a->progress->Set($progress[$j][1]);
-			    $a->progress->SetPattern($this->iSimpleProgressStyle,
-						     $this->iSimpleProgressColor);
-			    $a->progress->SetFillColor($this->iSimpleProgressBkgColor);
-			    //$a->progress->SetPattern($progress[$j][2],$progress[$j][3]);
-			    break;
-			}
-		    }
-		    $csimpos = 6;
-		    break;
-
-		case ACTYPE_MILESTONE:
-		    $a = new MileStone($data[$i][0],$data[$i][2],$data[$i][3]);
-		    $a->title->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
-		    $a->caption->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
-		    $csimpos = 5;
-		    break;
-		default:
-		    die('Unknown activity type');
-		    break;
-	    }
-
-	    // Setup caption
-	    $a->caption->Set($data[$i][$csimpos-1]);
-
-	    // Check if this activity should have a CSIM target ?
-	    if( !empty($data[$i][$csimpos]) ) {
-		$a->SetCSIMTarget($data[$i][$csimpos]);
-		$a->SetCSIMAlt($data[$i][$csimpos+1]);
-	    }
-	    if( !empty($data[$i][$csimpos+2]) ) {
-		$a->title->SetCSIMTarget($data[$i][$csimpos+2]);
-		$a->title->SetCSIMAlt($data[$i][$csimpos+3]);
-	    }
-
-	    $this->Add($a);
-	}
-    }
-
-	
+        $num = count($data);
+        for( $i=0; $i < $num; ++$i) {
+            switch( $data[$i][1] ) {
+                case ACTYPE_GROUP:
+                    // Create a slightly smaller height bar since the
+                    // "wings" at the end will make it look taller
+                    $a = new GanttBar($data[$i][0],$data[$i][2],$data[$i][3],$data[$i][4],'',8);
+                    $a->title->SetFont($this->iSimpleFont,FS_BOLD,$this->iSimpleFontSize);
+                    $a->rightMark->Show();
+                    $a->rightMark->SetType(MARK_RIGHTTRIANGLE);
+                    $a->rightMark->SetWidth(8);
+                    $a->rightMark->SetColor('black');
+                    $a->rightMark->SetFillColor('black');
+
+                    $a->leftMark->Show();
+                    $a->leftMark->SetType(MARK_LEFTTRIANGLE);
+                    $a->leftMark->SetWidth(8);
+                    $a->leftMark->SetColor('black');
+                    $a->leftMark->SetFillColor('black');
+
+                    $a->SetPattern(BAND_SOLID,'black');
+                    $csimpos = 6;
+                    break;
+
+                case ACTYPE_NORMAL:
+                    $a = new GanttBar($data[$i][0],$data[$i][2],$data[$i][3],$data[$i][4],'',10);
+                    $a->title->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
+                    $a->SetPattern($this->iSimpleStyle,$this->iSimpleColor);
+                    $a->SetFillColor($this->iSimpleBkgColor);
+                    // Check if this activity should have a constrain line
+                    $n = count($constrains);
+                    for( $j=0; $j < $n; ++$j ) {
+                        if( empty($constrains[$j]) || (count($constrains[$j]) != 3) ) {
+                            JpGraphError::RaiseL(6003,$j);
+                            //("Invalid format for Constrain parameter at index=$j in CreateSimple(). Parameter must start with index 0 and contain arrays of (Row,Constrain-To,Constrain-Type)");
+                        }
+                        if( $constrains[$j][0]==$data[$i][0] ) {
+                            $a->SetConstrain($constrains[$j][1],$constrains[$j][2],'black',ARROW_S2,ARROWT_SOLID);
+                        }
+                    }
+
+                    // Check if this activity have a progress bar
+                    $n = count($progress);
+                    for( $j=0; $j < $n; ++$j ) {
+
+                        if( empty($progress[$j]) || (count($progress[$j]) != 2) ) {
+                            JpGraphError::RaiseL(6004,$j);
+                            //("Invalid format for Progress parameter at index=$j in CreateSimple(). Parameter must start with index 0 and contain arrays of (Row,Progress)");
+                        }
+                        if( $progress[$j][0]==$data[$i][0] ) {
+                            $a->progress->Set($progress[$j][1]);
+                            $a->progress->SetPattern($this->iSimpleProgressStyle,
+                            $this->iSimpleProgressColor);
+                            $a->progress->SetFillColor($this->iSimpleProgressBkgColor);
+                            //$a->progress->SetPattern($progress[$j][2],$progress[$j][3]);
+                            break;
+                        }
+                    }
+                    $csimpos = 6;
+                    break;
+
+                case ACTYPE_MILESTONE:
+                    $a = new MileStone($data[$i][0],$data[$i][2],$data[$i][3]);
+                    $a->title->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
+                    $a->caption->SetFont($this->iSimpleFont,FS_NORMAL,$this->iSimpleFontSize);
+                    $csimpos = 5;
+                    break;
+                default:
+                    die('Unknown activity type');
+                    break;
+            }
+
+            // Setup caption
+            $a->caption->Set($data[$i][$csimpos-1]);
+
+            // Check if this activity should have a CSIM targetï¿œ?
+            if( !empty($data[$i][$csimpos]) ) {
+                $a->SetCSIMTarget($data[$i][$csimpos]);
+                $a->SetCSIMAlt($data[$i][$csimpos+1]);
+            }
+            if( !empty($data[$i][$csimpos+2]) ) {
+                $a->title->SetCSIMTarget($data[$i][$csimpos+2]);
+                $a->title->SetCSIMAlt($data[$i][$csimpos+3]);
+            }
+
+            $this->Add($a);
+        }
+    }
+
+    // Set user specified scale zoom factor when auto sizing is used
+    function SetZoomFactor($aZoom) {
+    	$this->iZoomFactor = $aZoom;
+    }
+
+
     // Set what headers should be shown
     function ShowHeaders($aFlg) {
-	$this->scale->ShowHeaders($aFlg);
-    }
-	
-    // Specify the fraction of the font height that should be added 
+        $this->scale->ShowHeaders($aFlg);
+    }
+
+    // Specify the fraction of the font height that should be added
     // as vertical margin
     function SetLabelVMarginFactor($aVal) {
-	$this->iLabelVMarginFactor = $aVal;
+        $this->iLabelVMarginFactor = $aVal;
     }
 
     // Synonym to the method above
     function SetVMarginFactor($aVal) {
-	$this->iLabelVMarginFactor = $aVal;
-    }
-	
-	
+        $this->iLabelVMarginFactor = $aVal;
+    }
+
+
     // Add a new Gantt object
     function Add($aObject) {
-	if( is_array($aObject) && count($aObject) > 0 ) {
-	    $cl = $aObject[0];
-	    if( class_exists('IconPlot',false) && ($cl instanceof IconPlot) ) {
-		$this->AddIcon($aObject);
-	    }
-	    else {
-		$n = count($aObject);
-		for($i=0; $i < $n; ++$i)
-		    $this->iObj[] = $aObject[$i];
-	    }
+        if( is_array($aObject) && count($aObject) > 0 ) {
+            $cl = $aObject[0];
+            if( class_exists('IconPlot',false) && ($cl instanceof IconPlot) ) {
+                $this->AddIcon($aObject);
+            }
+            elseif( class_exists('Text',false) && ($cl instanceof Text) ) {
+            	$this->AddText($aObject);
+            }
+            else {
+                $n = count($aObject);
+                for($i=0; $i < $n; ++$i)
+                $this->iObj[] = $aObject[$i];
+            }
+        }
+        else {
+            if( class_exists('IconPlot',false) && ($aObject instanceof IconPlot) ) {
+                $this->AddIcon($aObject);
+            }
+            elseif( class_exists('Text',false) && ($aObject instanceof Text) ) {
+            	$this->AddText($aObject);
+            }
+            else {
+                $this->iObj[] = $aObject;
+            }
+        }
+    }
+
+	function StrokeTexts() {
+        // Stroke any user added text objects
+        if( $this->texts != null ) {
+        	$n = count($this->texts);
+            for($i=0; $i < $n; ++$i) {
+            	if( $this->texts[$i]->iScalePosX !== null && $this->texts[$i]->iScalePosY !== null ) {
+            		$x = $this->scale->TranslateDate($this->texts[$i]->iScalePosX);
+            		$y = $this->scale->TranslateVertPos($this->texts[$i]->iScalePosY);
+            		$y -= $this->scale->GetVertSpacing()/2;
+            	}
+            	else {
+            		$x = $y = null;
+            	}
+                $this->texts[$i]->Stroke($this->img,$x,$y);
+            }
+        }
 	}
-	else {
-	    if( class_exists('IconPlot',false) && ($aObject instanceof IconPlot) ) {
-		$this->AddIcon($aObject);
-	    }
-	    else {	    
-		$this->iObj[] = $aObject;
-	    }
-	}
-    }
 
     // Override inherit method from Graph and give a warning message
     function SetScale($aAxisType,$aYMin=1,$aYMax=1,$aXMin=1,$aXMax=1) {
-	JpGraphError::RaiseL(6005);
-//("SetScale() is not meaningfull with Gantt charts.");
+        JpGraphError::RaiseL(6005);
+        //("SetScale() is not meaningfull with Gantt charts.");
     }
 
@@ -522,13 +551,13 @@
     // automtically determined from the input data)
     function SetDateRange($aStart,$aEnd) {
-	// Adjust the start and end so that the indicate the
-	// begining and end of respective start and end days
-	if( strpos($aStart,':') === false )
-	    $aStart = date('Y-m-d 00:00',strtotime($aStart));
-	if( strpos($aEnd,':') === false )
-	    $aEnd = date('Y-m-d 23:59',strtotime($aEnd));
-	$this->scale->SetRange($aStart,$aEnd);
-    }
-	
+        // Adjust the start and end so that the indicate the
+        // begining and end of respective start and end days
+        if( strpos($aStart,':') === false )
+        $aStart = date('Y-m-d 00:00',strtotime($aStart));
+        if( strpos($aEnd,':') === false )
+        $aEnd = date('Y-m-d 23:59',strtotime($aEnd));
+        $this->scale->SetRange($aStart,$aEnd);
+    }
+
     // Get the maximum width of the activity titles columns for the bars
     // The name is lightly misleading since we from now on can have
